import { select, range } from 'd3';

const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

const matrix = [
  [11975,  5871, 8916, 2868],
  [ 1951, 10048, 2060, 6171],
  [ 8010, 16145, 8090, 8045],
  [ 1013,   990,  940, 6907]
];

// console.log('after join', d3.select("body")
//   .append("table")
//   .selectAll("tr")
//   .data(matrix)
//   .join("tr"));

// console.log('after td data', d3.select("body")
//   .append("table")
//   .selectAll("tr")
//   .data(matrix)
//   .join("tr")
//   .selectAll("td")
//   .data(d => d));

// console.log('after text', d3.select("body")
//   .append("table")
//   .selectAll("tr")
//   .data(matrix)
//   .join("tr")
//   .selectAll("td")
//   .data(d => d)
//   .join("td")
//     .text(d => d))

// d3.select("body")
//   .append("table")
//   .selectAll("tr")
//   .data(matrix)
//   .join("tr")
//   .selectAll("td")
//   .data((d,i,a) => {console.log('td d', d); console.log('i', i); console.log('a', a); return d})
//   .join("td")
//     .text(d => {console.log('td join text d', d); return d});


// const data = [
//   {name: "Locke", number: 4},
//   {name: "Reyes", number: 8},
//   {name: "Ford", number: 15},
//   {name: "Jarrah", number: 16},
//   {name: "Shephard", number: 23},
//   {name: "Kwon", number: 42}
// ];

// d3.selectAll("div")
//   .data(data, function(d) { console.log('d', d); return d ? d.name : this.id; })
//     .text(d => d.number);

const makeFruit = type => ({ type });

const fruits = range(5)
	.map(() => makeFruit('apple'));

const render = (svg, {fruits}) => {
svg.selectAll("circle")
  .data(fruits)
  .join(
    enter => enter.append("circle")
  )
		.attr('cx', (d, i) => { console.log('d', d); console.log('i', i); return i * 120 + 60})
    .attr('cy', height /2 )
    .attr('fill', '#c11d1d')
    .attr('r', 50)
    .attr("fill", "none")
    .attr("stroke", "black");

}

render(svg, {fruits: fruits})

 select('.add')
  .on('click', () => {
   	console.log('clicked add button')
   	fruits.push({ type: 'apple'}) 
   	render(svg, {fruits})
   	console.log('fruits', fruits)
 	})

 select('.remove')
  .on('click', () => {
 		console.log('clicked remove button')
   	fruits.pop()
    render(svg, {fruits})
    console.log('fruits', fruits)
 	})

